VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "brParameter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de


Option Explicit

Implements CAPEOPEN.ICapeIdentification
Implements CAPEOPEN.ICapeParameter


Private cbObjRef As cOrbObjRef
Private cbObject As c_ICapeParameter


Friend Sub initCB(externalRef As String)

    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init
    End If
    
    Set cbObjRef = retrieveObject(externalRef)
    
    Set cbObject = m_ICapeParameter.narrow(cbObjRef)
           
End Sub

Friend Sub initCBobj(cbObj As cOrbObject)
    Set cbObject = m_ICapeParameter.narrow(cbObj)
End Sub

Private Property Let ICapeIdentification_ComponentDescription(ByVal RHS As String)
    cbObject.SetComponentDescription RHS
End Property

Private Property Get ICapeIdentification_ComponentDescription() As String
    ICapeIdentification_ComponentDescription = cbObject.GetComponentDescription
End Property

Private Property Let ICapeIdentification_ComponentName(ByVal RHS As String)
    cbObject.SetComponentName RHS
End Property

Private Property Get ICapeIdentification_ComponentName() As String
    ICapeIdentification_ComponentName = cbObject.GetComponentName
End Property

Private Property Get ICapeParameter_dirty() As Boolean
    If Not (cbObject.GetValStatus = 2) Then
        ICapeParameter_dirty = True
    Else
        ICapeParameter_dirty = False
    End If
End Property

'Private Property Let ICapeParameter_Mode(ByVal RHS As CAPEOPEN.CapeParamMode)
'    cbObject.SetMode RHS
'End Property
'
'Private Property Get ICapeParameter_Mode() As CAPEOPEN.CapeParamMode
'    ICapeParameter_Mode = cbObject.GetMode
'End Property
'
'Private Sub ICapeParameter_Reset()
'    cbObject.Reset
'End Sub

Private Property Let ICapeParameter_Specification(ByVal RHS As Object)

End Property

Private Property Get ICapeParameter_Specification() As Object
    Dim cbSpec As c_ICapeParameterSpec
    Set cbSpec = cbObject.GetSpecification
    
    Dim comRealSpec As brRealParameterSpec
    Dim comOptionSpec As brOptionParameterSpec
    Dim comIntSpec As brIntegerParameterSpec
    'Dim comBoolSpec As brBooleanParameterSpec
    
    Select Case cbSpec.GetType
        Case 0
          Set comRealSpec = New brRealParameterSpec 'CreateObject("unitBridge.brRealParameterSpec")
          comRealSpec.initCBobj cbSpec
          Set ICapeParameter_Specification = comRealSpec
        Case 2
          Set comOptionSpec = New brOptionParameterSpec 'CreateObject("unitBridge.brOptionParameterSpec")
          comOptionSpec.initCBobj cbSpec
          Set ICapeParameter_Specification = comOptionSpec
        Case 1, 3
          Set comIntSpec = New brIntegerParameterSpec
          comIntSpec.initCBobj cbSpec
          Set ICapeParameter_Specification = comIntSpec
'        Case CAPE_BOOLEAN
'          Set comBoolSpec = New brBooleanParameterSpec
'          comBoolSpec.initCBobj cbSpec
'          Set ICapeParameter_Specification = comBoolSpec
        Case Else
          Set ICapeParameter_Specification = Nothing
    End Select
    
End Property

Private Property Get ICapeParameter_valid() As Boolean
    Dim a As String
    ICapeParameter_valid = cbObject.Validate(a)
End Property

Private Sub ICapeParameter_Validate()
    Dim message As String
    Dim b As Boolean
    b = cbObject.Validate(message)
End Sub


'Private Property Get ICapeParameter_ValStatus() As CAPEOPEN.CapeValidationStatus
'    ICapeParameter_ValStatus = cbObject.GetValStatus
'End Property

Private Property Let ICapeParameter_value(ByVal RHS As Variant)
    Dim cbValue As cOrbAny
    Set cbValue = variant2Any(RHS)
    cbObject.SetValue cbValue
End Property

Private Property Get ICapeParameter_value() As Variant
    Dim cbValue As cOrbAny
    Set cbValue = cbObject.GetValue
    
    ICapeParameter_value = any2Variant(cbValue)
End Property

Private Property Let ICapeParameter_ValueSource(ByVal RHS As Long)

End Property

Private Property Get ICapeParameter_ValueSource() As Long
    ICapeParameter_ValueSource = 0
End Property
