VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "brRealParameterSpec"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de

Option Explicit

Implements CAPEOPEN.ICapeIdentification
Implements CAPEOPEN.ICapeParameterSpec
Implements CAPEOPEN.ICapeRealParameterSpec

Private cbObjRef As cOrbObjRef
Private cbObject As c_ICapeRealParameterSpec

Friend Sub initCB(externalRef As String)

    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init
    End If
    
    Set cbObjRef = retrieveObject(externalRef)
    
    Set cbObject = m_ICapeRealParameterSpec.narrow(cbObjRef)
           
End Sub

Friend Sub initCBobj(cbObj As cOrbObject)
    Set cbObject = m_ICapeRealParameterSpec.narrow(cbObj)
End Sub

Private Property Let ICapeIdentification_ComponentDescription(ByVal RHS As String)
    cbObject.SetComponentDescription RHS
End Property

Private Property Get ICapeIdentification_ComponentDescription() As String
    ICapeIdentification_ComponentDescription = cbObject.GetComponentDescription
End Property

Private Property Let ICapeIdentification_ComponentName(ByVal RHS As String)
    cbObject.SetComponentName RHS
End Property

Private Property Get ICapeIdentification_ComponentName() As String
    ICapeIdentification_ComponentName = cbObject.GetComponentName
End Property

Private Property Let ICapeParameterSpec_Dimensionality(ByVal RHS As Variant)

End Property

Private Property Get ICapeParameterSpec_Dimensionality() As Variant
' This property is currently not properly implemented because VBOrb
' does not support complex Any types (e.g. containing an array or sequence
' Possible workaround: Introduce a CORBA Any translator which encapsulates
' a sequence in an object. This object could be put into an Any which then
' is accessible by VBOrb
' Current implementation returns an array of long filled with 0
    
    Dim myVal(1 To 7) As Long
    
    ICapeParameterSpec_Dimensionality = myVal
    
End Property

Private Property Let ICapeParameterSpec_Mode(ByVal RHS As Long)

End Property

Private Property Get ICapeParameterSpec_Mode() As Long
    ICapeParameterSpec_Mode = 2
End Property

Private Property Let ICapeParameterSpec_Type(ByVal RHS As Long)
    
End Property

Private Property Get ICapeParameterSpec_Type() As Long
    ICapeParameterSpec_Type = cbObject.GetType
End Property

Private Property Let ICapeRealParameterSpec_DefaultValue(ByVal RHS As Double)

End Property

Private Property Get ICapeRealParameterSpec_DefaultValue() As Double
    ICapeRealParameterSpec_DefaultValue = cbObject.GetDefaultValue()
End Property

Private Property Let ICapeRealParameterSpec_LowerBound(ByVal RHS As Double)

End Property

Private Property Get ICapeRealParameterSpec_LowerBound() As Double
    ICapeRealParameterSpec_LowerBound = cbObject.GetLowerBound()
End Property

Private Property Let ICapeRealParameterSpec_UpperBound(ByVal RHS As Double)

End Property

Private Property Get ICapeRealParameterSpec_UpperBound() As Double
    ICapeRealParameterSpec_UpperBound = cbObject.GetUpperBound()
End Property

Private Function ICapeRealParameterSpec_Validate(ByVal value As Double, message As String) As Boolean
    On Error GoTo handler
    Dim myValRes As Boolean
    
    myValRes = cbObject.Validate(value, message)
    
    ICapeRealParameterSpec_Validate = myValRes
    
    Exit Function
handler:
    ICapeRealParameterSpec_Validate = False
End Function
