VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "brUnit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de

Option Explicit

Implements CAPEOPEN.ICapeUnit
Implements CAPEOPEN.ICapeIdentification
Implements CAPEOPEN.ICapeUnitEdit
Implements CAPEOPEN.ICapeUnitReport

Private cbObjRef As cOrbObjRef
Private cbObject As c_ICapeUnit

Private cbReportObject As c_ICapeUnitReport

Private myKSch As Variant


Friend Sub initCB(externalRef As String)

    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init
    End If
    
    Set cbObjRef = retrieveObject(externalRef)
    
    Set cbObject = m_ICapeUnit.narrow(cbObjRef)
           
End Sub

Friend Sub initCBobj(cbObj As cOrbObject)
    Set cbObject = m_ICapeUnit.narrow(cbObj)
End Sub

Private Sub Class_Initialize()
    
    If (myOrb Is Nothing) Then
        Set myOrb = VBOrb.init
    End If
    
    myKSch = Date
    
    timerForm.Show vbModal
     
    Set cbObject = cbUnitReference
    
    If (cbObject Is Nothing) Or Not (unitOK) Then
      Err.Raise vbObjectError
    End If
    
   


End Sub

Private Property Let ICapeIdentification_ComponentDescription(ByVal RHS As String)
    cbObject.SetComponentDescription RHS
End Property

Private Property Get ICapeIdentification_ComponentDescription() As String
    ICapeIdentification_ComponentDescription = cbObject.GetComponentDescription
End Property

Private Property Let ICapeIdentification_ComponentName(ByVal RHS As String)
    cbObject.SetComponentName RHS
End Property

Private Property Get ICapeIdentification_ComponentName() As String
    ICapeIdentification_ComponentName = cbObject.GetComponentName
End Property

Private Function ICapeUnit_Calculate(message As String) As Boolean
   cbObject.Calculate
   message = ""
   ICapeUnit_Calculate = True
End Function

'Private Sub ICapeUnit_Calculate()
'    cbObject.Calculate
'End Sub

Private Property Get ICapeUnit_dirty() As Boolean
    Dim myBool As Boolean
    If Not (cbObject.GetValStatus = 2) Then
        ICapeUnit_dirty = True
    Else
        ICapeUnit_dirty = False
    End If
End Property

Private Function ICapeUnit_Initialize(message As String) As Boolean
    message = ""
    cbObject.Initialize
    ICapeUnit_Initialize = True
End Function

'Private Sub ICapeUnit_Initializexxxx()
'    cbObject.Initialize
'End Sub

Private Property Get ICapeUnit_parameters() As Object
    Dim cbParams As c_ParmColl
    Set cbParams = cbObject.GetParameters
    
    Dim comParamColl As brParmCollection
    Set comParamColl = New brParmCollection 'CreateObject("unitBridge.brParmCollection")
    
    comParamColl.initCBobj cbParams
    
    Set ICapeUnit_parameters = comParamColl

End Property

Private Property Get ICapeUnit_ports() As Object
    Dim cbPorts As c_PortColl
    Set cbPorts = cbObject.GetPorts
    
    Dim comPortColl As brPortCollection
    Set comPortColl = New brPortCollection 'CreateObject("unitBridge.brPortCollection")
       
    comPortColl.initCBobj cbPorts
    
    Set ICapeUnit_ports = comPortColl
    
End Property


Private Function ICapeUnit_Restore(storage As Variant, message As String) As Boolean
    If (VarType(storage) = vbString) Then
        cbObject.Restore storage
    Else
        Err.Raise vbObjectError
    End If
    message = ""
    ICapeUnit_Restore = True
End Function


Private Function ICapeUnit_Save(storage As Variant, message As String) As Boolean
    If (VarType(storage) = vbString) Then
        cbObject.Save storage
    Else
        Err.Raise vbObjectError
    End If
    message = ""
    ICapeUnit_Save = True
End Function


Private Property Let ICapeUnit_simulationContext(ByVal RHS As Object)
    ' This method is not defined in CAPE-OPEN CORBA IDL
    ' Therefore, the bridge does not implement that method
    Err.Raise vbObjectError
End Property

Private Function ICapeUnit_Terminate(message As String) As Boolean
    cbObject.Terminate
    message = ""
    ICapeUnit_Terminate = True
End Function

'Private Sub ICapeUnit_Terminatexx()
'    cbObject.Terminate
'End Sub

Private Property Get ICapeUnit_valid() As Boolean
    
    ICapeUnit_valid = cbObject.Validate()
End Property

Private Function ICapeUnit_Validate() As Boolean
  ICapeUnit_Validate = cbObject.Validate()
End Function


Private Function ICapeUnitEdit_Edit(message As String) As Boolean
    Load unitDummyEditForm
    unitDummyEditForm.iorTextBox.Text = myOrb.objectToString(cbObject)
    unitDummyEditForm.Show vbModal
    Unload unitDummyEditForm
    message = ""
    ICapeUnitEdit_Edit = True
End Function

Private Function ICapeUnitReport_ProduceReport(message As String) As Boolean
    message = cbReportObject.ProduceReport
    ICapeUnitReport_ProduceReport = True
End Function

'Private Property Get ICapeUnit_ValStatus() As CAPEOPEN.CapeValidationStatus
'    ICapeUnit_ValStatus = cbObject.GetValStatus
'End Property


Private Property Get ICapeUnitReport_reports() As Variant
    If (cbReportObject Is Nothing) Then
        Set cbReportObject = cbObject.GetReportObject
    End If
    
    Dim result As c_StringSeq
    Set result = cbReportObject.GetReports
    
    Dim rVal As Variant
    rVal = stringSeq2Variant(result)
    
    ICapeUnitReport_reports = rVal
End Property

Private Property Let ICapeUnitReport_selectedReport(ByVal RHS As String)
    If (cbReportObject Is Nothing) Then
        Set cbReportObject = cbObject.GetReportObject
    End If
    
    cbReportObject.SetSelectedReport RHS
End Property

Private Property Get ICapeUnitReport_selectedReport() As String
    ICapeUnitReport_selectedReport = cbReportObject.GetSelectedReport
End Property
