Attribute VB_Name = "brUtils"
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' Example client for the bridged unit(c) 2001 Joerg Koeller
' original corba idl source file is a modified CO v0.92 CIDL

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.deOption Explicit
Option Explicit

Public Const myIDLVersion = "0.9.3"


' File names for report and temporary data storage
Public Const iorDir = "D:\dev\iors\"

Public myOrb As cOrbImpl
Public cbUnitReference
Public unitOK As Boolean

Const tk_null As Long = 0
Const tk_void As Long = 1
Const tk_short As Long = 2
Const tk_long As Long = 3
Const tk_ushort As Long = 4
Const tk_ulong As Long = 5
Const tk_float As Long = 6
Const tk_double As Long = 7
Const tk_boolean As Long = 8
Const tk_char As Long = 9
Const tk_octet As Long = 10
Const tk_any As Long = 11
Const tk_TypeCode As Long = 12
Const tk_Principal As Long = 13
Const tk_objref As Long = 14
Const tk_struct As Long = 15
Const tk_union As Long = 16
Const tk_enum As Long = 17
Const tk_string As Long = 18
Const tk_sequence As Long = 19
Const tk_array As Long = 20
Const tk_alias As Long = 21
Const tk_except As Long = 22
Const tk_longlong As Long = 23
Const tk_ulonglong As Long = 24
Const tk_longdouble As Long = 25
Const tk_wchar As Long = 26
Const tk_wstring As Long = 27
Const tk_fixed As Long = 28
Const tk_value As Long = 29
Const tk_value_box As Long = 30
Const tk_native As Long = 31
Const tk_abstract_interface As Long = 32
Const tk_recursive As Long = &HFFFFFFFF



' returns the type of a variant as a string
Public Function getVarType(myVariant As Variant) As String
    Select Case VarType(myVariant)
        Case vbEmpty
            getVarType = "empty"
        Case vbObject
            getVarType = "IDispatch"
        Case vbDouble
            getVarType = "double"
        Case vbBoolean
            getVarType = "boolean"
        Case vbLong
            getVarType = "long"
        Case vbString
            getVarType = "string"
        Case vbInteger
            getVarType = "integer"
        Case vbArray
            getVarType = "array"
        Case vbArray + vbLong
            getVarType = "array of long"
        Case vbArray + vbInteger
            getVarType = "array of integer"
        Case vbArray + vbDouble
            getVarType = "array of doubles"
        Case vbArray + vbString
            getVarType = "array of strings"
        Case vbArray + vbBoolean
            getVarType = "array of boolean"
        Case vbArray + vbObject
            getVarType = "array of IDispatch"
        Case Else
            getVarType = "unknown"
    End Select
End Function

' checks if the string s is contained in the array field
Public Function strLookUp(ByVal s As String, ByVal field As Variant) As Boolean

Dim i As Long
strLookUp = False

For i = LBound(field) To UBound(field)
    If (UCase(s) = UCase(field(i))) Then
        strLookUp = True
    End If
Next

End Function

Public Function retrieveObject(ByVal externalObjRef As String) As cOrbObjRef
    
    Dim myObjRef As cOrbObjRef
    
'    Dim fso As FileSystemObject
'    Dim iorFile As File
'    Dim iorStream As TextStream
'    Dim ior As String
'
'    If (myOrb Is Nothing) Then
'        Set myOrb = VBOrb.init
'    End If
'
'    Set fso = CreateObject("Scripting.FileSystemObject")
'    Set iorFile = fso.GetFile(iorFileName)
'    Set iorStream = iorFile.OpenAsTextStream(ForReading)
'    ior = iorStream.ReadLine()
    
    Set myObjRef = myOrb.stringToObject(externalObjRef)
    Set retrieveObject = myObjRef
    
End Function

Public Function stringSeq2Variant(ByVal sSeq As c_StringSeq) As Variant

    Dim seqLen As Long
    Dim i As Long
    Dim rVal As Variant
    
    seqLen = sSeq.Length
    If seqLen > 0 Then
        ReDim myStrings(0 To seqLen - 1) As String
        For i = 0 To seqLen - 1
            myStrings(i) = sSeq.Item(i)
        Next
        rVal = myStrings
    Else
        rVal = Empty
    End If
    
    stringSeq2Variant = rVal
End Function

Public Function variant2StringSeq(ByVal sVar As Variant) As c_StringSeq
    Dim rVal As c_StringSeq
    Set rVal = New c_StringSeq
    If VarType(sVar) = vbEmpty Then
        rVal.Length = 0
    Else
        rVal.Length = UBound(sVar) - LBound(sVar) + 1
        Dim i As Long
        For i = 0 To rVal.Length - 1
             rVal.Item(i) = sVar(i + LBound(sVar))
        Next
    End If
    Set variant2StringSeq = rVal
End Function

Public Function anySeq2Variant(ByVal anySeq As c_anySeq) As Variant

    Dim seqLen As Long
    Dim i As Long
    Dim rVal As Variant
    
    seqLen = anySeq.Length
    If seqLen > 0 Then
        
        ReDim myVariants(0 To seqLen - 1) As Variant
    
        Dim myAny As cOrbAny
        For i = 0 To seqLen - 1
            Set myAny = anySeq.Item(i)
            Select Case myAny.TCKind
                Case tk_long
                    myVariants(i) = myAny.getLong
                Case tk_string
                    myVariants(i) = myAny.getString
                Case tk_double
                    myVariants(i) = myAny.getDouble
                Case Else
                    Err.Raise vbObjectError
            End Select
        Next
        rVal = myVariants
    Else
        rVal = Empty
    End If
    anySeq2Variant = rVal
End Function

Public Function variant2AnySeq(ByVal aVar As Variant) As c_anySeq
    Dim myAny As cOrbAny
    Dim myVariant As Variant
    Dim rVal As c_anySeq
    Set rVal = New c_anySeq
    If VarType(aVar) = vbEmpty Then
        rVal.Length = 0
    Else
        rVal.Length = UBound(aVar) - LBound(aVar) + 1
        Dim i As Long
        For i = 0 To rVal.Length - 1
            Set myAny = New cOrbAny
            myVariant = aVar(i + LBound(aVar))
            Select Case VarType(myVariant)
                Case vbLong
                    myAny.setLong myVariant
                Case vbDouble
                    myAny.setDouble myVariant
                Case vbString
                    myAny.setString myVariant
                Case Else
                    Err.Raise vbObjectError
            End Select
            Set rVal.Item(i) = myAny
      
        Next
    End If
    Set variant2AnySeq = rVal

End Function

Public Function doubleSeq2Variant(ByVal dSeq As c_DoubleSeq) As Variant

    Dim seqLen As Long
    Dim i As Long
    Dim rVal As Variant
    
    seqLen = dSeq.Length
    If seqLen > 0 Then
        ReDim myDoubles(0 To seqLen - 1) As Double
        For i = 0 To seqLen - 1
            myDoubles(i) = dSeq.Item(i)
        Next
        rVal = myDoubles
    Else
        rVal = Empty
    End If
    doubleSeq2Variant = rVal
End Function

Public Function variant2DoubleSeq(ByVal dVar As Variant) As c_DoubleSeq
    Dim rVal As c_DoubleSeq
    Set rVal = New c_DoubleSeq
    If VarType(dVar) = vbEmpty Then
        rVal.Length = 0
    Else
        rVal.Length = UBound(dVar) - LBound(dVar) + 1
        Dim i As Long
        For i = 0 To rVal.Length - 1
            rVal.Item(i) = dVar(i + LBound(dVar))
        Next
    End If
    Set variant2DoubleSeq = rVal
End Function

Public Function booleanSeq2Variant(ByVal bSeq As c_BooleanSeq) As Variant

    Dim seqLen As Long
    Dim i As Long
    Dim rVal As Variant
    
    seqLen = bSeq.Length
    If seqLen > 0 Then
        ReDim myBools(0 To seqLen - 1) As Boolean
        For i = 0 To seqLen - 1
            myBools(i) = bSeq.Item(i)
        Next
        rVal = myBools
    Else
        rVal = Empty
    End If
    booleanSeq2Variant = rVal
End Function

Public Function variant2BooleanSeq(ByVal bVar As Variant) As c_BooleanSeq
    Dim rVal As c_BooleanSeq
    Set rVal = New c_BooleanSeq
    If VarType(bVar) = vbEmpty Then
        rVal.Length = 0
    Else
        rVal.Length = UBound(bVar) - LBound(bVar) + 1
        Dim i As Long
        For i = 0 To rVal.Length - 1
            rVal.Item(i) = bVar(i + LBound(bVar))
        Next
    End If
    Set variant2BooleanSeq = rVal
End Function

Public Function variant2Any(ByVal myVariant As Variant) As cOrbAny
    
    Dim rVal As cOrbAny
    Set rVal = New cOrbAny
    
    Select Case VarType(myVariant)
        Case vbLong
            rVal.setLong myVariant
        Case vbDouble
            rVal.setDouble myVariant
        Case vbString
            rVal.setString myVariant
        Case vbBoolean
            rVal.setBoolean myVariant
        Case vbEmpty
            rVal.setNull
        Case Else
            Err.Raise vbObjectError
    End Select
    
    Set variant2Any = rVal
    
End Function

Public Function any2Variant(ByVal myAny As cOrbAny) As Variant
   Dim rVal As Variant
   
   Select Case myAny.TCKind
        Case tk_long
            rVal = myAny.getLong
        Case tk_double
            rVal = myAny.getDouble
        Case tk_string
            rVal = myAny.getString
        Case tk_boolean
            rVal = myAny.getBoolean
        Case tk_null
            rVal = Empty
        Case Else
            Err.Raise vbObjectError
    End Select
    
    any2Variant = rVal
End Function
