VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cbMatObjImpl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'CORBA stub and core code. Copyright (c) 2001  Joerg Koeller
'original source file is a modified CO v0.92 CIDL

' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de

Option Explicit

'You can use this class as a tie to your servant or as a servant example.
'Using as a tie:
' Your servant hat to implement c_MatObj
' To activate a servant via tie write following:
'  Dim oMatObjImplTie As c_MatObjImplTie
'  Set oMatObjImplTie = New c_MatObjImplTie
'  Call oMatObjImplTie.setDelegate(oServant)
'  Call oOrb.Connect(oMatObjImplTie)
'Using as a servant example:
' Rename class to c_MatObjImpl and save the file as c_MatObjImpl.cls.
' Remove delegate stuff and write your own servant operations.
' To activate a servant write following:
'  Dim oMatObjImpl As c_MatObjImpl
'  Set oMatObjImpl = New c_MatObjImpl
'  Call oOrb.Connect(oMatObjImpl)

Implements cOrbSkeleton
Implements c_MatObj

'interface ::CapeOpen::Thrm::Cose::ICapeThermoMaterialObject
Const sTypeId As String = "IDL:CapeOpen/Thrm/Cose/ICapeThermoMaterialObject:1.0"
Private oObjRef As cOrbObjRef
Private oDelegate As c_MatObj


Private comObj As Object
Private comMO As CAPEOPEN.ICapeThermoMaterialObject
Private comII As CAPEOPEN.ICapeIdentification

Public Sub setComObj(comObject As Object)
    Set comObj = comObject
    Set comMO = comObj
    Set comII = comObj
End Sub

'Public Function getComObj() As Object
'    Set getComObj = comObj
'End Function

Public Function getDelegate() As c_MatObj
    Set getDelegate = oDelegate
End Function

Friend Property Get ObjRef() As cOrbObjRef
    Set ObjRef = oObjRef
End Property

Friend Property Get This() As c_MatObj
    Dim oObj As cOrbObject
    Set oObj = New c_MatObj
    If oObj.setObjRef(oObjRef, False) Then
        Set This = Nothing
    Else
        Set This = oObj
    End If
End Property

Private Sub Class_Initialize()
    If (cbUnitReference Is Nothing) Then
      Err.Raise vbObjectError
    End If
End Sub

Private Property Get cOrbSkeleton_TypeId(ByVal Item As Integer) As String
    Select Case Item
    Case 0: cOrbSkeleton_TypeId = sTypeId
    Case 1: cOrbSkeleton_TypeId = "IDL:omg.org/CORBA/Object:1.0"
    End Select
End Property

Private Property Get cOrbSkeleton_ObjRef() As cOrbObjRef
    Set cOrbSkeleton_ObjRef = oObjRef
End Property

Private Property Set cOrbSkeleton_ObjRef(ByVal newObjRef As cOrbObjRef)
    Set oObjRef = newObjRef
End Property

'Helper
Private Function cOrbSkeleton_execute(ByVal sOperation As String, _
    ByVal oIn As cOrbStream, ByVal oOut As cOrbStream) As Long
    On Error GoTo ErrHandler
    Dim oImpl_ As c_MatObj
    Set oImpl_ = IIf(oDelegate Is Nothing, Me, oDelegate)
    Select Case sOperation
    Case "GetComponentIds"
        Dim GetComponentIds As c_StringSeq
        Set GetComponentIds = oImpl_.GetComponentIds()
        Call GetComponentIds.writeMe(oOut, 0)
    Case "GetPhaseIds"
        Dim GetPhaseIds As c_StringSeq
        Set GetPhaseIds = oImpl_.GetPhaseIds()
        Call GetPhaseIds.writeMe(oOut, 0)
    Case "GetNumComponents"
        Dim GetNumComponents As Long
        GetNumComponents = oImpl_.GetNumComponents()
        Call oOut.writeLong(GetNumComponents)
    Case "GetUniversalConstant"
        Dim a4_props As c_StringSeq
        Set a4_props = New c_StringSeq
        Call a4_props.readMe(oIn, 0)
        Dim GetUniversalConstant As c_anySeq
        Set GetUniversalConstant = oImpl_.GetUniversalConstant(a4_props)
        Call GetUniversalConstant.writeMe(oOut, 0)
    Case "GetComponentConstant"
        Dim a5_props As c_StringSeq
        Set a5_props = New c_StringSeq
        Call a5_props.readMe(oIn, 0)
        Dim a5_compIds As c_StringSeq
        Set a5_compIds = New c_StringSeq
        Call a5_compIds.readMe(oIn, 0)
        Dim GetComponentConstant As c_anySeq
        Set GetComponentConstant = oImpl_.GetComponentConstant(a5_props, _
            a5_compIds)
        Call GetComponentConstant.writeMe(oOut, 0)
    Case "CalcProp"
        Dim a6_props As c_StringSeq
        Set a6_props = New c_StringSeq
        Call a6_props.readMe(oIn, 0)
        Dim a6_phases As c_StringSeq
        Set a6_phases = New c_StringSeq
        Call a6_phases.readMe(oIn, 0)
        Dim a6_calcType As String
        a6_calcType = oIn.readString()
        Call oImpl_.CalcProp(a6_props, a6_phases, a6_calcType)
    Case "GetProp"
        Dim a7_property As String
        a7_property = oIn.readString()
        Dim a7_phase As String
        a7_phase = oIn.readString()
        Dim a7_compIds As c_StringSeq
        Set a7_compIds = New c_StringSeq
        Call a7_compIds.readMe(oIn, 0)
        Dim a7_calcType As String
        a7_calcType = oIn.readString()
        Dim a7_basis As String
        a7_basis = oIn.readString()
        Dim GetProp As c_DoubleSeq
        Set GetProp = oImpl_.GetProp(a7_property, a7_phase, a7_compIds, _
            a7_calcType, a7_basis)
        Call GetProp.writeMe(oOut, 0)
    Case "SetProp"
        Dim a8_property As String
        a8_property = oIn.readString()
        Dim a8_phase As String
        a8_phase = oIn.readString()
        Dim a8_compIds As c_StringSeq
        Set a8_compIds = New c_StringSeq
        Call a8_compIds.readMe(oIn, 0)
        Dim a8_calcType As String
        a8_calcType = oIn.readString()
        Dim a8_basis As String
        a8_basis = oIn.readString()
        Dim a8_values As c_DoubleSeq
        Set a8_values = New c_DoubleSeq
        Call a8_values.readMe(oIn, 0)
        Call oImpl_.SetProp(a8_property, a8_phase, a8_compIds, a8_calcType, _
            a8_basis, a8_values)
    Case "CalcEquilibrium"
        Dim a9_flashType As String
        a9_flashType = oIn.readString()
        Dim a9_props As c_StringSeq
        Set a9_props = New c_StringSeq
        Call a9_props.readMe(oIn, 0)
        Call oImpl_.CalcEquilibrium(a9_flashType, a9_props)
    Case "PropCheck"
        Dim a10_props As c_StringSeq
        Set a10_props = New c_StringSeq
        Call a10_props.readMe(oIn, 0)
        Dim PropCheck As c_BooleanSeq
        Set PropCheck = oImpl_.PropCheck(a10_props)
        Call PropCheck.writeMe(oOut, 0)
    Case "ValidityCheck"
        Dim a11_props As c_StringSeq
        Set a11_props = New c_StringSeq
        Call a11_props.readMe(oIn, 0)
        Dim ValidityCheck As c_ICapeThermoReliabilitySeq
        Set ValidityCheck = oImpl_.ValidityCheck(a11_props)
        Call ValidityCheck.writeMe(oOut, 0)
    Case "GetAvailableProps"
        Dim GetAvailableProps As c_StringSeq
        Set GetAvailableProps = oImpl_.GetAvailableProps()
        Call GetAvailableProps.writeMe(oOut, 0)
    Case "Duplicate"
        Dim Duplicate As c_MatObj
        Set Duplicate = oImpl_.Duplicate()
        Call oOut.writeObject(Duplicate)
    Case "GetIndependentVar"
        Dim a14_indVars As c_StringSeq
        Set a14_indVars = New c_StringSeq
        Call a14_indVars.readMe(oIn, 0)
        Dim GetIndependentVar As c_DoubleSeq
        Set GetIndependentVar = oImpl_.GetIndependentVar(a14_indVars)
        Call GetIndependentVar.writeMe(oOut, 0)
    Case "SetIndependentVar"
        Dim a15_indVars As c_StringSeq
        Set a15_indVars = New c_StringSeq
        Call a15_indVars.readMe(oIn, 0)
        Dim a15_values As c_DoubleSeq
        Set a15_values = New c_DoubleSeq
        Call a15_values.readMe(oIn, 0)
        Call oImpl_.SetIndependentVar(a15_indVars, a15_values)
    Case Else
        Call VBOrb.raiseBADOPERATION(1, CompletedNO, sOperation)
    End Select
    cOrbSkeleton_execute = 0 'NO_EXCEPTION
    Exit Function
UserExWriter:
    Call VBOrb.getException().writeMe(oOut)
    cOrbSkeleton_execute = 1 'USER_EXCEPTION
    Exit Function
ErrHandler:
    If VBOrb.ErrIsUserEx() Then Resume UserExWriter
    Call VBOrb.ErrReraise("ICapeThermoMaterialObject.execute(" & sOperation & ")")
End Function

'Implements c_MatObj

'GetComponentIds() raises(c_ECapeUnknown)
Private Function c_MatObj_GetComponentIds() As c_StringSeq
    On Error GoTo ErrHandler
    
    Dim comIds As Variant
    comIds = comMO.ComponentIds
    Dim rVal As c_StringSeq
    Set rVal = variant2StringSeq(comIds)
    
    Set c_MatObj_GetComponentIds = rVal
    
    Exit Function
ErrHandler:
    Set c_MatObj_GetComponentIds = Nothing
    Call VBOrb.ErrReraise("GetComponentIds")
End Function

'GetPhaseIds() raises(c_ECapeUnknown)
Private Function c_MatObj_GetPhaseIds() As c_StringSeq
    On Error GoTo ErrHandler
    
    Dim comPhases As Variant
    comPhases = comMO.PhaseIds
    Dim rVal As c_StringSeq
    Set rVal = variant2StringSeq(comPhases)
    
    Set c_MatObj_GetPhaseIds = rVal
    
    Exit Function
ErrHandler:
    Set c_MatObj_GetPhaseIds = Nothing
    Call VBOrb.ErrReraise("GetPhaseIds")
End Function

'GetNumComponents() raises(c_ECapeUnknown)
Private Function c_MatObj_GetNumComponents() As Long
    On Error GoTo ErrHandler
    
    c_MatObj_GetNumComponents = comMO.GetNumComponents
    
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetNumComponents")
End Function

'GetUniversalConstant() raises(c_ECapeUnknown, c_ECapeInvalidArgument, _
    c_ECapeNoImpl)
Private Function c_MatObj_GetUniversalConstant(ByVal props As c_StringSeq) _
    As c_anySeq
    On Error GoTo ErrHandler
    
    Dim comProps As Variant
    comProps = stringSeq2Variant(props)
    
    Dim comConsts As Variant
    comConsts = comMO.GetUniversalConstant(comProps)
    
    Dim rVal As c_anySeq
    Set rVal = variant2AnySeq(comConsts)
    
    Set c_MatObj_GetUniversalConstant = rVal
    
    Exit Function
ErrHandler:
    Set c_MatObj_GetUniversalConstant = Nothing
    Call VBOrb.ErrReraise("GetUniversalConstant")
End Function

'GetComponentConstant() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Private Function c_MatObj_GetComponentConstant(ByVal props As c_StringSeq, _
    ByVal compIds As c_StringSeq) As c_anySeq
    On Error GoTo ErrHandler
    
    Dim comProps As Variant
    comProps = stringSeq2Variant(props)
    
    Dim comCompIds As Variant
    comCompIds = stringSeq2Variant(compIds)
    
    Dim comConsts As Variant
    comConsts = comMO.GetComponentConstant(comProps, comCompIds)
    
    Dim rVal As c_anySeq
    Set rVal = variant2AnySeq(comConsts)
    
    Set c_MatObj_GetComponentConstant = rVal
    
    Exit Function

ErrHandler:
    Set c_MatObj_GetComponentConstant = Nothing
    Call VBOrb.ErrReraise("GetComponentConstant")
End Function

'CalcProp() raises(c_ECapeUnknown, c_ECapeInvalidArgument, c_ECapeSolvingError, _
    c_ECapeOutOfBounds, c_ECapeLicenceError)
Private Sub c_MatObj_CalcProp(ByVal props As c_StringSeq, _
    ByVal phases As c_StringSeq, ByVal calcType As String)
    On Error GoTo ErrHandler
    
    Dim comProps As Variant
    comProps = stringSeq2Variant(props)
    Dim comPhases As Variant
    comPhases = stringSeq2Variant(phases)
    
    comMO.CalcProp comProps, comPhases, calcType
    
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("CalcProp")
End Sub

'GetProp() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Private Function c_MatObj_GetProp(ByVal property_ As String, _
    ByVal phase As String, ByVal compIds As c_StringSeq, _
    ByVal calcType As String, ByVal basis As String) As c_DoubleSeq
    On Error GoTo ErrHandler
    
    Dim comCompIds As Variant
    comCompIds = stringSeq2Variant(compIds)
    Dim result As Variant
    result = comMO.GetProp(property_, phase, comCompIds, calcType, basis)
        
    Dim rVal As c_DoubleSeq
    Set rVal = variant2DoubleSeq(result)
        
    Set c_MatObj_GetProp = rVal
    
    Exit Function
ErrHandler:
    Set c_MatObj_GetProp = Nothing
    Call VBOrb.ErrReraise("GetProp")
End Function

'SetProp() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Private Sub c_MatObj_SetProp(ByVal property_ As String, ByVal phase As String, _
    ByVal compIds As c_StringSeq, ByVal calcType As String, _
    ByVal basis As String, ByVal values As c_DoubleSeq)
    On Error GoTo ErrHandler
    
    Dim comCompIds As Variant
    comCompIds = stringSeq2Variant(compIds)
    Dim comValues As Variant
    comValues = doubleSeq2Variant(values)
    
    comMO.SetProp property_, phase, comCompIds, calcType, basis, comValues
    
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetProp")
End Sub

'CalcEquilibrium() raises(c_ECapeUnknown, c_ECapeInvalidArgument, _
    c_ECapeBadInvOrder, c_ECapeSolvingError, c_ECapeOutOfBounds, _
    c_ECapeLicenceError)
Private Sub c_MatObj_CalcEquilibrium(ByVal flashType As String, _
    ByVal props As c_StringSeq)
    On Error GoTo ErrHandler
    
    Dim comProps As Variant
    comProps = stringSeq2Variant(props)
    
    comMO.CalcEquilibrium flashType, comProps
    
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("CalcEquilibrium")
End Sub

'PropCheck() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Private Function c_MatObj_PropCheck(ByVal props As c_StringSeq) As c_BooleanSeq
    On Error GoTo ErrHandler
    
    Dim comProps As Variant
    comProps = stringSeq2Variant(props)
    
    Dim result As Variant
    result = comMO.PropCheck(comProps)
    
    Dim rVal As c_BooleanSeq
    Set rVal = variant2BooleanSeq(result)
    
    Set c_MatObj_PropCheck = rVal
    
    Exit Function
ErrHandler:
    Set c_MatObj_PropCheck = Nothing
    Call VBOrb.ErrReraise("PropCheck")
End Function

'ValidityCheck() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Private Function c_MatObj_ValidityCheck(ByVal props As c_StringSeq) _
    As c_ICapeThermoReliabilitySeq
    
' Method is not implemented because ICapeThermoReliability is not defined so far
' in the CAPE-OPEN standard
    
    On Error GoTo ErrHandler
    
    Err.Raise vbObjectError
        
    Exit Function
ErrHandler:
    Set c_MatObj_ValidityCheck = Nothing
    Call VBOrb.ErrReraise("ValidityCheck")
End Function

'GetAvailableProps() raises(c_ECapeUnknown)
Private Function c_MatObj_GetAvailableProps() As c_StringSeq
    On Error GoTo ErrHandler
    
    Dim result As Variant
    result = comMO.AvailableProps
    
    Dim rVal As c_StringSeq
    Set rVal = variant2StringSeq(result)
    
    Set c_MatObj_GetAvailableProps = rVal
    
    Exit Function
ErrHandler:
    Set c_MatObj_GetAvailableProps = Nothing
    Call VBOrb.ErrReraise("GetAvailableProps")
End Function

'Duplicate() raises(c_ECapeUnknown)
Private Function c_MatObj_Duplicate() As c_MatObj
    On Error GoTo ErrHandler
    
    Dim newComMO As CAPEOPEN.ICapeThermoMaterialObject
    Set newComMO = comMO.Duplicate
    
    Dim newCBMo As cbMatObjImpl
    Set newCBMo = New cbMatObjImpl
    newCBMo.setComObj newComMO
    myOrb.connect newCBMo
    
    Dim rVal As c_MatObj
    Set rVal = m_MatObj.narrow(newCBMo.ObjRef)
    
    Set c_MatObj_Duplicate = rVal
    Exit Function
ErrHandler:
    Set c_MatObj_Duplicate = Nothing
    Call VBOrb.ErrReraise("Duplicate")
End Function

'GetIndependentVar()
Private Function c_MatObj_GetIndependentVar(ByVal indVars As c_StringSeq) _
    As c_DoubleSeq
    On Error GoTo ErrHandler
    
    Dim comIndVars As Variant
    comIndVars = stringSeq2Variant(indVars)
    Dim result As Variant
    result = comMO.GetIndependentVar(comIndVars)
        
    Dim rVal As c_DoubleSeq
    Set rVal = variant2DoubleSeq(result)
    
    Set c_MatObj_GetIndependentVar = rVal
    Exit Function
ErrHandler:
    Set c_MatObj_GetIndependentVar = Nothing
    Call VBOrb.ErrReraise("GetIndependentVar")
End Function

'SetIndependentVar()
Private Sub c_MatObj_SetIndependentVar(ByVal indVars As c_StringSeq, _
    ByVal values As c_DoubleSeq)
    On Error GoTo ErrHandler
    
    Dim comIndVars As Variant
    comIndVars = stringSeq2Variant(indVars)
    Dim comValues As Variant
    comValues = doubleSeq2Variant(values)
    
    comMO.SetIndependentVar comIndVars, comValues
    
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetIndependentVar")
End Sub
