VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "c_ECapeUnknown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' Example client for the bridged unit(c) 2001 Joerg Koeller
' original corba idl source file is a modified CO v0.92 CIDL

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.deOption Explicit


Option Explicit

Implements cOrbException

'exception ::CapeOpen::Common::Error::ECapeUnknown
Const sTypeId As String = "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
Private sSource As String
Private sPostDescr As String

Public code As Long
Public p_description As String
Public scope As String
Public interfaceName As String
Public Operation As String
Public moreInfo As String

Private Property Get cOrbException_TypeId() As String
    cOrbException_TypeId = sTypeId
End Property

Private Property Get cOrbException_Source() As String
    cOrbException_Source = sSource
End Property

Private Property Get cOrbException_Description() As String
    cOrbException_Description = "CORBA User Exception: [" & sTypeId & "], " & _
        TypeName(Me) & sPostDescr
End Property

Private Sub cOrbException_addInfos(Optional ByRef SourcePrefix As String = "", _
    Optional ByRef PostDescr As String = "")
    If sSource = "" Then
        sSource = SourcePrefix
    ElseIf SourcePrefix <> "" Then
        sSource = SourcePrefix & ": " & sSource
    End If
    If PostDescr <> "" Then
        sPostDescr = sPostDescr & ", " & PostDescr
    End If
End Sub

'Helper
Private Sub cOrbException_readMe(ByVal oIn As cOrbStream)
    On Error GoTo ErrHandler
    code = oIn.readLong()
    p_description = oIn.readString()
    scope = oIn.readString()
    interfaceName = oIn.readString()
    Operation = oIn.readString()
    moreInfo = oIn.readString()
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("ECapeUnknown.read")
End Sub

'Helper
Private Sub cOrbException_writeMe(ByVal oOut As cOrbStream)
    On Error GoTo ErrHandler
    Call oOut.writeString(sTypeId)
    Call oOut.writeLong(code)
    Call oOut.writeString(p_description)
    Call oOut.writeString(scope)
    Call oOut.writeString(interfaceName)
    Call oOut.writeString(Operation)
    Call oOut.writeString(moreInfo)
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("ECapeUnknown.write")
End Sub
