VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "c_ICapeParameter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'CORBA stub and core code. Copyright (c) 2001  Joerg Koeller
'original source file is a modified CO v0.92 CIDL

' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de
Option Explicit

Implements cOrbAbstractBase
Implements cOrbObject

'interface ::CapeOpen::Common::Parameter::ICapeParameter
Const sTypeId As String = "IDL:CapeOpen/Common/Parameter/ICapeParameter:1.0"
Private oObjRef As cOrbObjRef

'Helper
Private Function cOrbAbstractBase_isObjRef() As Boolean
    cOrbAbstractBase_isObjRef = True
End Function

'Helper
Private Function cOrbObject_setObjRef(ByVal ObjRef As cOrbObjRef, _
    ByVal Check As Boolean) As Boolean
    On Error GoTo ErrHandler
    If ObjRef Is Nothing Then
        cOrbObject_setObjRef = True
    Else
        cOrbObject_setObjRef = False
        Call ObjRef.narrow(sTypeId, Check, False)
    End If
    Set oObjRef = ObjRef
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("setObjRef")
End Function

'Helper
Private Function cOrbObject_getObjRef() As cOrbObjRef
    Set cOrbObject_getObjRef = oObjRef
End Function

'Helper
Private Function cOrbObject_getId() As String
    cOrbObject_getId = sTypeId
End Function

'GetComponentName() raises(c_ECapeUnknown)
Public Function GetComponentName() As String
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetComponentName", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetComponentName = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetComponentName")
End Function

'SetComponentName() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetComponentName(ByVal name As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetComponentName", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(name)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetComponentName")
End Sub

'GetComponentDescription() raises(c_ECapeUnknown)
Public Function GetComponentDescription() As String
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetComponentDescription", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetComponentDescription = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetComponentDescription")
End Function

'SetComponentDescription() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetComponentDescription(ByVal desc As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetComponentDescription", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(desc)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetComponentDescription")
End Sub

'GetValue() raises(c_ECapeUnknown)
Public Function GetValue() As cOrbAny
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetValue", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Set GetValue = New cOrbAny
        Call GetValue.readMe(oIn)
    End If
    Exit Function
ErrHandler:
    Set GetValue = Nothing
    Call VBOrb.ErrReraise("GetValue")
End Function

'SetValue() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetValue(ByVal value As cOrbAny)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetValue", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call value.writeMe(oOut)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetValue")
End Sub

'GetValStatus() raises(c_ECapeUnknown)
Public Function GetValStatus() As Long
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetValStatus", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetValStatus = oIn.readUlong()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetValStatus")
End Function

'GetMode() raises(c_ECapeUnknown)
Public Function GetMode() As Long
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetMode", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetMode = oIn.readUlong()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetMode")
End Function

'SetMode() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetMode(ByVal mode As Long)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetMode", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeUlong(mode)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetMode")
End Sub

'GetSpecification() raises(c_ECapeUnknown, c_ECapeNoImpl)
Public Function GetSpecification() As c_ICapeParameterSpec
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetSpecification", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeNoImpl:1.0"
            Set oUserEx = New c_ECapeNoImpl
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Set GetSpecification = m_ICapeParameterSpec.narrow(oIn.readObject())
    End If
    Exit Function
ErrHandler:
    Set GetSpecification = Nothing
    Call VBOrb.ErrReraise("GetSpecification")
End Function

'Validate() raises(c_ECapeUnknown, c_ECapeOutOfBounds)
Public Function Validate(ByRef message As String) As Boolean
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Validate", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeOutOfBounds:1.0"
            Set oUserEx = New c_ECapeOutOfBounds
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Validate = oIn.readBoolean()
        message = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("Validate")
End Function

'Reset() raises(c_ECapeUnknown)
Public Sub Reset()
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Reset", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Reset")
End Sub
