VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "c_ICapeUnit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'CORBA stub and core code. Copyright (c) 2001  Joerg Koeller
'original source file is a modified CO v0.92 CIDL

' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de
Option Explicit

Implements cOrbAbstractBase
Implements cOrbObject

'interface ::CapeOpen::Unit::ICapeUnit
Const sTypeId As String = "IDL:CapeOpen/Unit/ICapeUnit:1.0"
Private oObjRef As cOrbObjRef

'Helper
Private Function cOrbAbstractBase_isObjRef() As Boolean
    cOrbAbstractBase_isObjRef = True
End Function

'Helper
Private Function cOrbObject_setObjRef(ByVal ObjRef As cOrbObjRef, _
    ByVal Check As Boolean) As Boolean
    On Error GoTo ErrHandler
    If ObjRef Is Nothing Then
        cOrbObject_setObjRef = True
    Else
        cOrbObject_setObjRef = False
        Call ObjRef.narrow(sTypeId, Check, False)
    End If
    Set oObjRef = ObjRef
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("setObjRef")
End Function

'Helper
Private Function cOrbObject_getObjRef() As cOrbObjRef
    Set cOrbObject_getObjRef = oObjRef
End Function

'Helper
Private Function cOrbObject_getId() As String
    cOrbObject_getId = sTypeId
End Function

'GetComponentName() raises(c_ECapeUnknown)
Public Function GetComponentName() As String
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetComponentName", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetComponentName = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetComponentName")
End Function

'SetComponentName() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetComponentName(ByVal name As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetComponentName", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(name)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetComponentName")
End Sub

'GetComponentDescription() raises(c_ECapeUnknown)
Public Function GetComponentDescription() As String
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetComponentDescription", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetComponentDescription = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetComponentDescription")
End Function

'SetComponentDescription() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetComponentDescription(ByVal desc As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetComponentDescription", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(desc)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetComponentDescription")
End Sub

'Initialize() raises(c_ECapeUnknown, c_ECapeLicenceError, _
    c_ECapeFailedInitialisation, c_ECapeOutOfResources)
Public Sub Initialize()
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Initialize", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeLicenceError:1.0"
            Set oUserEx = New c_ECapeLicenceError
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeFailedInitialisation:1.0"
            Set oUserEx = New c_ECapeFailedInitialisation
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeOutOfResources:1.0"
            Set oUserEx = New c_ECapeOutOfResources
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Initialize")
End Sub

'Terminate() raises(c_ECapeUnknown, c_ECapeBadInvOrder)
Public Sub Terminate()
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Terminate", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadInvOrder:1.0"
            Set oUserEx = New c_ECapeBadInvOrder
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Terminate")
End Sub

'Calculate() raises(c_ECapeUnknown, c_ECapeBadInvOrder, c_ECapeOutOfResources, _
    c_ECapeTimeOut, c_ECapeSolvingError, c_ECapeLicenceError)
Public Sub Calculate()
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Calculate", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadInvOrder:1.0"
            Set oUserEx = New c_ECapeBadInvOrder
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeOutOfResources:1.0"
            Set oUserEx = New c_ECapeOutOfResources
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeTimeOut:1.0"
            Set oUserEx = New c_ECapeTimeOut
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeSolvingError:1.0"
            Set oUserEx = New c_ECapeSolvingError
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeLicenceError:1.0"
            Set oUserEx = New c_ECapeLicenceError
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Calculate")
End Sub

'GetPorts() raises(c_ECapeUnknown, c_ECapeFailedInitialisation, _
    c_ECapeBadInvOrder)
Public Function GetPorts() As c_PortColl
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetPorts", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeFailedInitialisation:1.0"
            Set oUserEx = New c_ECapeFailedInitialisation
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadInvOrder:1.0"
            Set oUserEx = New c_ECapeBadInvOrder
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Set GetPorts = m_PortColl.narrow(oIn.readObject())
    End If
    Exit Function
ErrHandler:
    Set GetPorts = Nothing
    Call VBOrb.ErrReraise("GetPorts")
End Function

'GetParameters() raises(c_ECapeUnknown, c_ECapeFailedInitialisation, _
    c_ECapeBadInvOrder, c_ECapeBadCOParameter)
Public Function GetParameters() As c_ParmColl
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetParameters", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeFailedInitialisation:1.0"
            Set oUserEx = New c_ECapeFailedInitialisation
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadInvOrder:1.0"
            Set oUserEx = New c_ECapeBadInvOrder
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadCOParameter:1.0"
            Set oUserEx = New c_ECapeBadCOParameter
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Set GetParameters = m_ParmColl.narrow(oIn.readObject())
    End If
    Exit Function
ErrHandler:
    Set GetParameters = Nothing
    Call VBOrb.ErrReraise("GetParameters")
End Function

'Validate() raises(c_ECapeUnknown, c_ECapeBadCOParameter, c_ECapeBadInvOrder)
Public Function Validate() As Boolean
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Validate", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadCOParameter:1.0"
            Set oUserEx = New c_ECapeBadCOParameter
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadInvOrder:1.0"
            Set oUserEx = New c_ECapeBadInvOrder
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Validate = oIn.readBoolean()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("Validate")
End Function

'GetValStatus() raises(c_ECapeUnknown, c_ECapeBadInvOrder)
Public Function GetValStatus() As Long
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetValStatus", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeBadInvOrder:1.0"
            Set oUserEx = New c_ECapeBadInvOrder
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetValStatus = oIn.readUlong()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetValStatus")
End Function

'GetReportObject() raises(c_ECapeUnknown)
Public Function GetReportObject() As c_ICapeUnitReport
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetReportObject", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Set GetReportObject = m_ICapeUnitReport.narrow(oIn.readObject())
    End If
    Exit Function
ErrHandler:
    Set GetReportObject = Nothing
    Call VBOrb.ErrReraise("GetReportObject")
End Function

'Save() raises(c_ECapeUnknown, c_ECapeInvalidArgument, _
    c_ECapePersistenceNotFound, c_ECapeIllegalAccess, c_ECapeNoImpl)
Public Sub Save(ByVal storage As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Save", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(storage)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapePersistenceNotFound:1.0"
            Set oUserEx = New c_ECapePersistenceNotFound
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeIllegalAccess:1.0"
            Set oUserEx = New c_ECapeIllegalAccess
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeNoImpl:1.0"
            Set oUserEx = New c_ECapeNoImpl
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Save")
End Sub

'Restore() raises(c_ECapeUnknown, c_ECapeInvalidArgument, _
    c_ECapePersistenceNotFound, c_ECapeIllegalAccess, c_ECapeNoImpl)
Public Sub Restore(ByVal storage As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Restore", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(storage)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapePersistenceNotFound:1.0"
            Set oUserEx = New c_ECapePersistenceNotFound
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeIllegalAccess:1.0"
            Set oUserEx = New c_ECapeIllegalAccess
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeNoImpl:1.0"
            Set oUserEx = New c_ECapeNoImpl
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Restore")
End Sub

'Destroy() raises(c_ECapeUnknown)
Public Function destroy() As Boolean
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Destroy", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        destroy = oIn.readBoolean()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("Destroy")
End Function
