VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "c_UnitPort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' CAPE-OPEN Unit Bridge (c) 2001 Joerg Koeller

' Example client for the bridged unit(c) 2001 Joerg Koeller
' original corba idl source file is a modified CO v0.92 CIDL

' CAUTION: This software comes without any warranty whatsoever.
' You use this software at your very own risk. The author is
' is not responsible for any damage cause directly or indirectly
' by the use of this software.

' This software may be used for educational purposes only. Any
' commercial use neither as source code nor as binary even in
' parts or modified form is strictly
' prohibited and requires a written permission by the author.
' You can contact the author via e-mail: mandrox@web.de
Option Explicit

Implements cOrbAbstractBase
Implements cOrbObject

'interface ::CapeOpen::Unit::ICapeUnitPort
Const sTypeId As String = "IDL:CapeOpen/Unit/ICapeUnitPort:1.0"
Private oObjRef As cOrbObjRef

'Helper
Private Function cOrbAbstractBase_isObjRef() As Boolean
    cOrbAbstractBase_isObjRef = True
End Function

'Helper
Private Function cOrbObject_setObjRef(ByVal ObjRef As cOrbObjRef, _
    ByVal Check As Boolean) As Boolean
    On Error GoTo ErrHandler
    If ObjRef Is Nothing Then
        cOrbObject_setObjRef = True
    Else
        cOrbObject_setObjRef = False
        Call ObjRef.narrow(sTypeId, Check, False)
    End If
    Set oObjRef = ObjRef
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("setObjRef")
End Function

'Helper
Private Function cOrbObject_getObjRef() As cOrbObjRef
    Set cOrbObject_getObjRef = oObjRef
End Function

'Helper
Private Function cOrbObject_getId() As String
    cOrbObject_getId = sTypeId
End Function

'GetComponentName() raises(c_ECapeUnknown)
Public Function GetComponentName() As String
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetComponentName", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetComponentName = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetComponentName")
End Function

'SetComponentName() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetComponentName(ByVal name As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetComponentName", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(name)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetComponentName")
End Sub

'GetComponentDescription() raises(c_ECapeUnknown)
Public Function GetComponentDescription() As String
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetComponentDescription", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetComponentDescription = oIn.readString()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetComponentDescription")
End Function

'SetComponentDescription() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub SetComponentDescription(ByVal desc As String)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("SetComponentDescription", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeString(desc)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("SetComponentDescription")
End Sub

'GetType() raises(c_ECapeUnknown, c_ECapeFailedInitialisation)
Public Function GetType() As Long
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetType", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeFailedInitialisation:1.0"
            Set oUserEx = New c_ECapeFailedInitialisation
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetType = oIn.readUlong()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetType")
End Function

'GetDirection() raises(c_ECapeUnknown, c_ECapeFailedInitialisation)
Public Function GetDirection() As Long
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetDirection", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeFailedInitialisation:1.0"
            Set oUserEx = New c_ECapeFailedInitialisation
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        GetDirection = oIn.readUlong()
    End If
    Exit Function
ErrHandler:
    Call VBOrb.ErrReraise("GetDirection")
End Function

'GetConnectedObject() raises(c_ECapeUnknown, c_ECapeFailedInitialisation)
Public Function GetConnectedObject() As c_MatObj
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("GetConnectedObject", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeFailedInitialisation:1.0"
            Set oUserEx = New c_ECapeFailedInitialisation
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    Else
        Set oIn = oRequest.OutRes
        Set GetConnectedObject = m_MatObj.narrow(oIn.readObject())
    End If
    Exit Function
ErrHandler:
    Set GetConnectedObject = Nothing
    Call VBOrb.ErrReraise("GetConnectedObject")
End Function

'Connect() raises(c_ECapeUnknown, c_ECapeInvalidArgument)
Public Sub connect(ByVal matObj As c_MatObj)
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Connect", False)
    Dim oOut As cOrbStream
    Set oOut = oRequest.InArg
    Call oOut.writeObject(matObj)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case "IDL:CapeOpen/Common/Error/ECapeInvalidArgument:1.0"
            Set oUserEx = New c_ECapeInvalidArgument
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Connect")
End Sub

'Disconnect() raises(c_ECapeUnknown)
Public Sub disconnect()
    On Error GoTo ErrHandler
    Dim oRequest As cOrbRequest
    Set oRequest = oObjRef.Request("Disconnect", False)
    Dim oIn As cOrbStream
    If oRequest.invokeReqst(True) Then
        Set oIn = oRequest.OutRes
        Dim sTypeId As String
        sTypeId = oIn.readString()
        Dim oUserEx As cOrbException
        Select Case sTypeId
        Case "IDL:CapeOpen/Common/Error/ECapeUnknown:1.0"
            Set oUserEx = New c_ECapeUnknown
            Call oUserEx.readMe(oIn)
        Case Else
            Call VBOrb.raiseUNKNOWN(1, CompletedMAYBE, _
                "Undefined CORBA User Exception: [" & sTypeId & "]")
        End Select
        Call VBOrb.raiseUserEx(oUserEx)
    End If
    Exit Sub
ErrHandler:
    Call VBOrb.ErrReraise("Disconnect")
End Sub
